#include <stdio.h>
#include <stdlib.h>

#include "udm_config.h"
#ifdef HAVE_GETOPT_H
#include <getopt.h>
#endif

#include "udmsearch.h"


void usage(){

	fprintf(stderr,
"\n\
splitter from UdmSearch v.%s\n\
http://search.mnogo.ru (C) 1998-2000, UdmSearch Developers Team.\n\
\n\
Usage: splitter [OPTIONS]\n\
\n\
Options are:\n\
  -f xx         start at xx.log, where xx is a hex number \n\
  -t xx         stop  at xx.log, where xx is a hex number\n\
  -h,-?         print this help page and exit\n\
\n\
Please mail bug reports and suggestions to <udmsearch@search.udm.net>.\n",UdmVersion());

	return;
}


int main(int argc,char **argv){
int ch,log;
int from=0;
int to=0xFF;

	while ((ch = getopt(argc, argv, "t:f:h?")) != -1){
		switch (ch) {
			case 'f':
				sscanf(optarg,"%x",&from);
				if(from<0)from=0;
				if(from>0xFF)from=0xFF; 
				break;	
			case 't': 
				sscanf(optarg,"%x",&to);
				if(to<0)to=0;
				if(to>0xFF)to=0xFF;
				break;
			case 'h':
			case '?':
			default:
				usage();
				return 1;
				break;
		}
	}
	argc -= optind;argv += optind;

	if(argc>0){
		usage();
		return 1;
	}

	for(log=from;log<=to;log++){
		printf("Splitting log #%08X\n",log);
		UdmSplitCacheLog(log);
	}
	
	return 0;
}
